=== debian/changelog ===
mimalloc (2.0.5+ds-2) unstable; urgency=medium

  * Strip mimalloc-2.0 from include installation path. (Closes: #1006249)

 -- Gürkan Myczko <tar@debian.org>  Wed, 23 Feb 2022 21:33:01 +0100

mimalloc (2.0.5+ds-1) unstable; urgency=medium

  * New upstream release.
  * d/copyright: update year.

 -- Gürkan Myczko <tar@debian.org>  Tue, 15 Feb 2022 09:08:27 +0100

mimalloc (2.0.3+ds-2) unstable; urgency=medium

  * Fix FTBFS by linking atomic.

 -- Gürkan Myczko <tar@debian.org>  Mon, 14 Feb 2022 23:35:00 +0100
