## mimalloc 2.0.6+ds

=== debian/changelog ===
mimalloc (2.0.6+ds-2) unstable; urgency=medium

  * Move CMake files to -dev package.
  * Apply patch to fix FTBFS for atomic platforms.
    Thanks Roger Shimizu.

 -- Gürkan Myczko <tar@debian.org>  Tue, 19 Jul 2022 08:56:02 +0200

mimalloc (2.0.6+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 18 Apr 2022 12:18:05 +0200

mimalloc (2.0.5+ds-3) unstable; urgency=medium

  * Also ship cmake config files. (Closes: #1008993)

 -- Gürkan Myczko <tar@debian.org>  Wed, 06 Apr 2022 12:27:44 +0200
