## mimalloc 2.0.7+ds

=== debian/changelog ===
mimalloc (2.0.7+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Sun, 06 Nov 2022 21:23:56 +0100
