## mimalloc 2.0.9+ds

=== debian/changelog ===
mimalloc (2.0.9+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.

 -- Gürkan Myczko <tar@debian.org>  Tue, 03 Jan 2023 13:04:46 +0100
