=== debian/rules ===
--- 
+++ 
@@ -10,8 +10,9 @@
 # package maintainers to append LDFLAGS
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+LIBATOMIC=OFF
 ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mips mipsel powerpc powerpcspe sh4))
-  export DEB_LDFLAGS_MAINT_APPEND=-latomic
+  LIBATOMIC=ON
 endif
 
 %:
@@ -19,7 +20,11 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-	-DMI_BUILD_STATIC=OFF
+	-DMI_BUILD_STATIC=OFF \
+	-DMI_BUILD_OBJECT=OFF \
+	-DMI_BUILD_TESTS=OFF \
+	-DMI_INSTALL_TOPLEVEL=ON \
+	-DMI_USE_LIBATOMIC=$(LIBATOMIC) \
 
 override_dh_missing:
 	@echo ACK
