## mimalloc 2.1.2+ds

=== debian/changelog ===
mimalloc (2.1.2+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Gürkan Myczko <tar@debian.org>  Mon, 12 Jun 2023 09:54:29 +0200

mimalloc (2.1.2+ds-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Tue, 09 May 2023 09:24:42 +0200

mimalloc (2.1.1+ds-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Tue, 04 Apr 2023 12:48:05 +0200

mimalloc (2.1.0+ds-1) experimental; urgency=medium

  * New upstream version.
  * Bump standards version to 4.6.2.

 -- Gürkan Myczko <tar@debian.org>  Fri, 31 Mar 2023 14:56:39 +0200

mimalloc (2.0.9+ds-2) unstable; urgency=medium

  * d/rules: specify build type. (Closes: #1030108)

 -- Gürkan Myczko <tar@debian.org>  Tue, 31 Jan 2023 10:21:15 +0100
