=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
+	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
 	-DMI_BUILD_STATIC=OFF \
 	-DMI_BUILD_OBJECT=OFF \
 	-DMI_BUILD_TESTS=OFF \
