## mimalloc 2.1.4+ds

=== debian/changelog ===
mimalloc (2.1.4+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.
  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Wed, 24 Apr 2024 06:22:04 +0200
