## mimalloc 2.1.7+ds

=== debian/changelog ===
mimalloc (2.1.7+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: add bin to Files-Excluded.
  * d/rules: skip dh_dwz.

 -- Alex Myczko <tar@debian.org>  Thu, 23 May 2024 07:59:28 +0000
