=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: mimalloc
 Priority: optional
-Maintainer: Gürkan Myczko <tar@debian.org>
+Maintainer: Alex Myczko <tar@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://github.com/microsoft/mimalloc
 Vcs-Browser: https://salsa.debian.org/debian/mimalloc
