=== debian/rules ===
--- 
+++ 
@@ -29,3 +29,6 @@
 
 override_dh_missing:
 	@echo ACK
+
+override_dh_dwz:
+	@echo YES
