=== debian/changelog ===
mimalloc (3.0.1+ds-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: Build without additional -march flags to fix baseline
    violation (Closes: #1094881, 1094269)
  * debian/control: Add Breaks+Replaces for misplaced file (Closes: #1094235)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 21 Feb 2025 10:54:41 +0100

mimalloc (3.0.1+ds-2) unstable; urgency=medium

  * d/control: updates to reflect library transition. (Closes: #1092293)
  * d/libmimalloc2.0* to libmimalloc3* update. (Closes: #1092330)

 -- Alex Myczko <tar@debian.org>  Fri, 24 Jan 2025 13:37:20 +0000

mimalloc (3.0.1+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Mon, 06 Jan 2025 11:46:07 +0000
