=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmimalloc2.0 (= ${binary:Version}), ${misc:Depends}
+Depends: libmimalloc3 (= ${binary:Version}), ${misc:Depends}
 Description: compact general purpose allocator with excellent performance (devel files)
  This is a general purpose allocator with excellent performance characteristics.
  Initially developed by Daan Leijen for the run-time systems of the Koka and
@@ -26,10 +26,12 @@
  .
  This package contains the development files.
 
-Package: libmimalloc2.0
+Package: libmimalloc3
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: libmimalloc2.0 (<< 3.0.1+ds-2)
+Replaces: libmimalloc2.0 (<< 3.0.1+ds-2)
 Description: compact general purpose allocator with excellent performance
  This is a general purpose allocator with excellent performance characteristics.
  Initially developed by Daan Leijen for the run-time systems of the Koka and
