=== debian/changelog ===
mimalloc (3.0.3+ds-1) unstable; urgency=medium

  * Ack NMUs.
  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Thu, 03 Apr 2025 09:13:17 +0000
