=== debian/changelog ===
mimalloc (3.1.5+ds-2) unstable; urgency=medium

  * d/rules: disable tests.

 -- Alex Myczko <tar@debian.org>  Mon, 15 Sep 2025 09:25:22 +0200

mimalloc (3.1.5+ds-1) experimental; urgency=medium

  * New upstream version.
  * Ack NMUs.
  * d/copyright: bump years.
  * d/rules: enable tests.
  * d/shlibs.local: dropped.

 -- Alex Myczko <tar@debian.org>  Tue, 09 Sep 2025 09:49:17 +0200

mimalloc (3.0.3+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -DMI_NO_OPT_ARCH=ON rather than -DMI_OPT_ARCH=OFF, since the
    latter is ineffective on systems that the build system thinks are arm64
    (closes: #1103589).

 -- Colin Watson <cjwatson@debian.org>  Wed, 13 Aug 2025 12:06:40 +0100
