=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 	-DMI_BUILD_OBJECT=OFF \
 	-DMI_BUILD_TESTS=OFF \
 	-DMI_INSTALL_TOPLEVEL=ON \
-	-DMI_OPT_ARCH=OFF \
+	-DMI_NO_OPT_ARCH=ON \
 	-DMI_USE_LIBATOMIC=$(LIBATOMIC) \
 
 override_dh_missing:
